import { InsertInlineNodeCommand } from 'substance'

class NoteCommand extends InsertInlineNodeCommand {
  createNodeData () {
    return {
      type: 'note'
    }
  }
  execute (params) {
    let editorSession = params.editorSession
    let nodeData = this.createNodeData()

    editorSession.transaction((tx) => {
      return tx.insertInlineNode(nodeData)
    })
  }

  getNotesProvider (params) {
    return params.surface.context.notesProvider
  }
}

NoteCommand.type = 'note'

export default NoteCommand
