import _ from 'lodash'

import { TOCProvider } from 'substance'

class NotesProvider extends TOCProvider {
  computeEntries () {
    const doc = this.getDocument()
    const nodes = doc.getNodes()

    if (docMini)console.log('paragraphs', nodesMini)

    // get all notes from the document
    const noteNodes = _.pickBy(nodes, function (value, key) {
      return value.type === 'note'
    })

    const sortedNoteEntries = this.sortNodes(noteNodes)

    return sortedNoteEntries
  }

  sortNodes (nodes) {
    let notes = _.clone(nodes)
    const doc = this.getDocument()
    const container = doc.get('body')

    // sort notes by
    //   the index of the containing block
    //   their position within that block

    notes = _.map(notes, function (note) {
      const blockId = note.path[0]
      const blockPosition = container.getPosition(blockId)
      const nodePosition = note.start.offset

      return {
        id: note.id,
        'note-content': note['note-content'],
        blockPosition: blockPosition,
        nodePosition: nodePosition
      }
    })

    return _.sortBy(notes, ['blockPosition', 'nodePosition'])
  }

  showNote (note) {
    const notes = this.computeEntries()
    const miniNote = _.find(notes.mini, ['parentNoteId', note.id])
    if (miniNote) this.config.miniEditorContext.editor.emit('noteSelected', miniNote.id)
  }
}

NotesProvider.tocTypes = ['note']

export default NotesProvider
